
// *** The Penurious Outskirts v1.0 *** 11/1/2006 *** 2:43:00 AM ***

// *** (C)opyright 2006 by Tucan Entertainment / http://www.tucan-entertainment.com/ ***

// *** Author: Duncan Mac Leod ***

include "mercenaries.xs"; // ensure extras
void main(void)
{
rmSetMapSize(450,450);
rmSetMapElevationParameters(cElevTurbulence, 0.02, 2.0, 0.5, 5.0);
rmSetMapElevationHeightBlend(0.2);
rmTerrainInitialize("patagonia\ground_dirt3_pat",2);
rmSetMapType("newEngland");
rmSetMapType("grass");
rmSetMapType("default");
rmSetMapType("water");
rmSetMapType("land");
rmSetLightingSet("st_petersburg_night");
rmSetSeaLevel(2);
rmSetStatusText("",0.10);
int Distanz = 36;
int MengeRessourcen = 0;
int GesamtMengeRessourcen = (cNumberNonGaiaPlayers * MengeRessourcen);
If (GesamtMengeRessourcen > 20) Distanz = 32;
If (GesamtMengeRessourcen > 30) Distanz = 28;
If (GesamtMengeRessourcen > 40) Distanz = 25;
If (GesamtMengeRessourcen > 50) Distanz = 22;
If (GesamtMengeRessourcen > 60) Distanz = 18;
int CLIFFSIZE = rmGetMapXSize()* 1.3;
int SEASIZE = rmGetMapXSize() * 2.3;
int FORESTSIZE = rmGetMapXSize()*1.3;
int ForestCount = rmGetMapXSize() / 7;
int SeaCount = (rmGetMapXSize() / 15);
int CliffCount = (rmGetMapXSize() / 25);
chooseMercs();
int PlayerClass=rmDefineClass("Player");
int LakeClass=rmDefineClass("Lakes");
int CliffClass=rmDefineClass("Cliffs");
rmDefineClass("ExplorerUnit");
rmDefineClass("MainForest");
rmDefineClass("MainItems");
rmDefineClass("Nativ");
int Lakes=rmCreateClassDistanceConstraint("LAKETOLAKE",LakeClass, 6.0);
int LPLayer=rmCreateClassDistanceConstraint("COTOPL", PlayerClass,rmXFractionToMeters(0.15));
int SPLAYER=rmCreateClassDistanceConstraint("PLTOPL", PlayerClass, 8.0);
int TCvsTC=rmCreateTypeDistanceConstraint("TCTOTC", "TownCenter", 30.0);
int CWvsCW=rmCreateTypeDistanceConstraint("CWTOCW", "CoveredWagon", 30.0);
int FOvsTC=rmCreateTypeDistanceConstraint("FOTOTC", "TownCenter", 20.0);
int AVCoin=rmCreateTypeDistanceConstraint("COTOCO", "gold", Distanz);
int AVNugget=rmCreateTypeDistanceConstraint("NUTONU", "abstractNugget", Distanz);
int AVLAND1=rmCreateTerrainDistanceConstraint("NIMPLAND", "Land", false, 6.0);
int AVLAND3=rmCreateTerrainDistanceConstraint("LIMPLAND", "Land", false, 5.0);
int FOvsCW=rmCreateTypeDistanceConstraint("FOTOCW", "CoveredWagon", 20.0);
int AVTC=rmCreateTypeDistanceConstraint("LALLTOTC", "TownCenter", 30.0);
int AVCW=rmCreateTypeDistanceConstraint("MTOCW", "CoveredWagon", 30.0);
int FOvsFO=rmCreateClassDistanceConstraint("FOTOFO", rmClassID("MainForest"), 20.0);
int AVANIMAL=rmCreateTypeDistanceConstraint("ANTOAN", "deer", 30.0);
int AVLAND2=rmCreateTerrainDistanceConstraint("SIMPLAND", "Land", false, 2.0);
int AVFishFish=rmCreateTypeDistanceConstraint("FISHTOFISH", "abstractFish", 15.0);
int AVFishLand = rmCreateTerrainDistanceConstraint("FISHTOLAND", "land", true, 9.0);
int AVAll=rmCreateTypeDistanceConstraint("ALLTOALL", "all", 4.0);
int AVTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 5.0);
int AVNativeTrade = rmCreateTypeDistanceConstraint("NATTOSOK", "socketTradeRoute", 5.0);
int AVSocket = rmCreateTypeDistanceConstraint("SOKTOSOK", "socketTradeRoute", 15.0);
int AVImpItem=rmCreateClassDistanceConstraint("SOKTOALL", rmClassID("MainItems"), 10.0);
int AVSilverSockets=rmCreateClassDistanceConstraint("SILTOSOCK", rmClassID("MainItems"), 12.0);
int AVRiver = rmCreateTerrainDistanceConstraint("SSWATER", "River", false, 3.0);
int AVWater8 = rmCreateTerrainDistanceConstraint("SWATER", "Land", false, 8.0);
int AVWater16 = rmCreateTerrainDistanceConstraint("MWATER", "Land", false, 16.0);
int AVWater20 = rmCreateTerrainDistanceConstraint("LWATER", "Land", false, 20.0);
int Cliff= rmCreateClassDistanceConstraint("CLIFFTOCLIFF",CliffClass, 8.0);
int ANativ=rmCreateClassDistanceConstraint("NATONA", rmClassID("Nativ"), 50.0);
int FLLAND = rmCreateTerrainDistanceConstraint("FlLand", "land", true, 3.0);
int FLVSFL = rmCreateTypeDistanceConstraint("FlToFl", "HomeCityWaterSpawnFlag",2);
rmSetStatusText("",0.20);
If (rmAllocateSubCivs(4) == true)
{
int subCiv00=rmGetCivID("Seminoles");
rmSetSubCiv(0, "Seminoles");
int subCiv01=rmGetCivID("Comanche");
rmSetSubCiv(1, "Comanche");
int subCiv02=rmGetCivID("Lakota");
rmSetSubCiv(2, "Lakota");
int subCiv03=rmGetCivID("Nootka");
rmSetSubCiv(3,"Nootka");
}
rmSetStatusText("",0.30);
rmSetPlacementTeam(0);
rmPlacePlayersLine(0.50, 0.75, 0.60, 0.85, 0, 5);
rmSetPlacementTeam(1);
rmPlacePlayersLine(0.50, 0.15, 0.60, 0.25, 0, 5);
float AreaSizePlayer = rmAreaTilesToFraction(700);
for(i=1; <cNumberPlayers)
{
int id=rmCreateArea("Player"+i);
rmSetPlayerArea(i, id);
rmSetAreaWarnFailure(id, false);
rmSetAreaSize(id, AreaSizePlayer, AreaSizePlayer);
rmAddAreaToClass(id, PlayerClass);
rmSetAreaLocPlayer(id, i);
rmSetAreaCoherence(id, 0.05);
rmSetAreaMinBlobs(id, 1);
rmSetAreaMaxBlobs(id, 1);
rmAddAreaConstraint(id, SPLAYER);
rmAddAreaConstraint(id, AVWater8);
rmBuildArea(id);
}
rmSetStatusText("",0.35);
for (I=1;<15)
{
int AREAL1=rmCreateArea("Spezial1"+I);
float A = rmRandFloat(0.05,0.98);
float B = rmRandFloat(0.05,0.98);
rmSetAreaWarnFailure(AREAL1, false);
rmSetAreaSize(AREAL1,rmAreaTilesToFraction(300),rmAreaTilesToFraction(300));
rmSetAreaCoherence(AREAL1, 0.05);
rmSetAreaMinBlobs(AREAL1, 1);
rmSetAreaMaxBlobs(AREAL1, 1);
rmSetAreaTerrainType(AREAL1,"pampas\ground1_pam");
rmAddAreaTerrainLayer(AREAL1, "great_plains\ground1_gp", 10, 15);
rmSetAreaLocation(AREAL1,A,B);
rmAddAreaConstraint(AREAL1, SPLAYER);
rmBuildArea(AREAL1);
}
for (I=1;<15)
{
int AREAL2=rmCreateArea("Spezial2"+I);
A = rmRandFloat(0.05,0.98);
B = rmRandFloat(0.05,0.98);
rmSetAreaWarnFailure(AREAL2, false);
rmSetAreaSize(AREAL2,rmAreaTilesToFraction(300),rmAreaTilesToFraction(300));
rmSetAreaCoherence(AREAL2, 0.05);
rmSetAreaMinBlobs(AREAL2, 1);
rmSetAreaMaxBlobs(AREAL2, 1);
rmSetAreaTerrainType(AREAL2,"great_plains\ground1_gp");
rmAddAreaTerrainLayer(AREAL1, "bayou\ground4_bay", 8, 15);
rmSetAreaLocation(AREAL2,A,B);
rmAddAreaConstraint(AREAL2, SPLAYER);
rmBuildArea(AREAL2);
}
for (I=1;<15)
{
int AREAL3=rmCreateArea("Spezial3"+I);
A = rmRandFloat(0.05,0.98);
B = rmRandFloat(0.05,0.98);
rmSetAreaWarnFailure(AREAL3, false);
rmSetAreaSize(AREAL3,rmAreaTilesToFraction(300),rmAreaTilesToFraction(300));
rmSetAreaCoherence(AREAL3, 0.05);
rmSetAreaMinBlobs(AREAL3, 1);
rmSetAreaMaxBlobs(AREAL3, 1);
rmSetAreaTerrainType(AREAL3,"bayou\ground4_bay");
rmAddAreaTerrainLayer(AREAL1, "patagonia\ground_dirt3_pat", 5, 15);
rmSetAreaLocation(AREAL3,A,B);
rmAddAreaConstraint(AREAL3, SPLAYER);
rmBuildArea(AREAL3);
}
vector TRP1 = cOriginVector;
vector TRP2 = cOriginVector;
int tradeRoute1 = rmCreateTradeRoute();
int tradeRoute2 = rmCreateTradeRoute();
int SocketID=rmCreateObjectDef("TradeSockets");
rmAddObjectDefItem(SocketID, "SocketTradeRoute", 1, 0.0);
rmAddObjectDefConstraint(SocketID, AVSocket);
rmAddObjectDefConstraint(SocketID, AVWater8);
rmAddObjectDefToClass(SocketID, rmClassID("MainItems"));

rmSetObjectDefMinDistance(SocketID, 0.0);
rmSetObjectDefMaxDistance(SocketID, 8.0);
rmAddClosestPointConstraint(AVWater8);
TRP1 = rmFindClosestPoint(1.00, 0.55, 1);
rmAddTradeRouteWaypoint(tradeRoute1,rmXMetersToFraction(xsVectorGetX(TRP1)),rmZMetersToFraction(xsVectorGetZ(TRP1)));
rmAddRandomTradeRouteWaypoints(tradeRoute1, 0.83,0.83,7,7);
rmAddRandomTradeRouteWaypoints(tradeRoute1, 0.50,0.95,7,7);
rmAddRandomTradeRouteWaypoints(tradeRoute1, 0.19,0.83,7,7);
TRP1 = rmFindClosestPoint(0.01, 0.58, 1);
rmAddRandomTradeRouteWaypoints(tradeRoute1, rmXMetersToFraction(xsVectorGetX(TRP1)),rmZMetersToFraction(xsVectorGetZ(TRP1)),7,7);
rmBuildTradeRoute(tradeRoute1, "dirt");
TRP2 = rmFindClosestPoint(0.00, 0.35, 1);
rmAddTradeRouteWaypoint(tradeRoute2, rmXMetersToFraction(xsVectorGetX(TRP2)), rmZMetersToFraction(xsVectorGetZ(TRP2)));
rmAddRandomTradeRouteWaypoints(tradeRoute2, 0.18, 0.18,4,4);
rmAddRandomTradeRouteWaypoints(tradeRoute2, 0.50, 0.05,4,4);
rmAddRandomTradeRouteWaypoints(tradeRoute2, 0.80, 0.15,4,4);
TRP2 = rmFindClosestPoint(1.00, 0.35, 1);
rmAddRandomTradeRouteWaypoints(tradeRoute2, rmXMetersToFraction(xsVectorGetX(TRP2)), rmZMetersToFraction(xsVectorGetZ(TRP2)),4,4);
rmBuildTradeRoute(tradeRoute2, "dirt");
rmClearClosestPointConstraints();
float Breite = 8;
If (cNumberNonGaiaPlayers == 2) Breite = (cNumberNonGaiaPlayers *5.0);
If (cNumberNonGaiaPlayers == 3) Breite = (cNumberNonGaiaPlayers *3.5);
If (cNumberNonGaiaPlayers == 4) Breite = (cNumberNonGaiaPlayers *2.5);
If (cNumberNonGaiaPlayers >= 5) Breite = (cNumberNonGaiaPlayers *2.0);
int amazonRiver1 = rmRiverCreate(-1, "Amazon River",13,13, Breite, Breite);
rmRiverAddWaypoint(amazonRiver1, 1.00, 0.40);
rmRiverAddWaypoint(amazonRiver1, 0.70, 0.60);
rmRiverAddWaypoint(amazonRiver1, 0.30, 0.40);
rmRiverAddWaypoint(amazonRiver1, 0.00, 0.50);
rmRiverSetBankNoiseParams(amazonRiver1, 0.07, 2, 1.5, 15.0, 1.0, 0.0);
int BreiteShallow = 6;
If (cNumberNonGaiaPlayers == 2) BreiteShallow = (cNumberNonGaiaPlayers * 2.0);
If (cNumberNonGaiaPlayers == 3) BreiteShallow = (cNumberNonGaiaPlayers * 1.7);
If (cNumberNonGaiaPlayers == 4) BreiteShallow = (cNumberNonGaiaPlayers * 1.3);
If (cNumberNonGaiaPlayers >= 5) BreiteShallow = (cNumberNonGaiaPlayers * 1.0);
float Point1 = rmRandFloat(0.05,0.95);
float Point2 = rmRandFloat(0.05,0.95);
float Point3 = rmRandFloat(0.05,0.95);
rmRiverSetShallowRadius(amazonRiver1, BreiteShallow);
rmRiverAddShallow(amazonRiver1, Point1);
rmRiverSetShallowRadius(amazonRiver1, BreiteShallow);
rmRiverAddShallow(amazonRiver1, Point2);
rmRiverSetShallowRadius(amazonRiver1, BreiteShallow);
rmRiverAddShallow(amazonRiver1, Point3);
rmRiverBuild(amazonRiver1);
rmRiverReveal(amazonRiver1, 1); 
vector SocketPosition = cOriginVector;
SocketPosition = rmGetTradeRouteWayPoint(tradeRoute1, 0.20);
rmPlaceObjectDefAtPoint(SocketID, 0, SocketPosition);
SocketPosition = rmGetTradeRouteWayPoint(tradeRoute1, 0.40);
rmPlaceObjectDefAtPoint(SocketID, 0, SocketPosition);
SocketPosition = rmGetTradeRouteWayPoint(tradeRoute1, 0.60);
rmPlaceObjectDefAtPoint(SocketID, 0, SocketPosition);
SocketPosition = rmGetTradeRouteWayPoint(tradeRoute1, 0.80);
rmPlaceObjectDefAtPoint(SocketID, 0, SocketPosition);
rmSetObjectDefTradeRouteID(SocketID, tradeRoute2);
SocketPosition = rmGetTradeRouteWayPoint(tradeRoute2, 0.20);
rmPlaceObjectDefAtPoint(SocketID, 0, SocketPosition);
SocketPosition = rmGetTradeRouteWayPoint(tradeRoute2, 0.40);
rmPlaceObjectDefAtPoint(SocketID, 0, SocketPosition);
SocketPosition = rmGetTradeRouteWayPoint(tradeRoute2, 0.60);
rmPlaceObjectDefAtPoint(SocketID, 0, SocketPosition);
SocketPosition = rmGetTradeRouteWayPoint(tradeRoute2, 0.80);
rmPlaceObjectDefAtPoint(SocketID, 0, SocketPosition);
int Fisch1=rmCreateObjectDef("Fisch1");
rmAddObjectDefItem(Fisch1, "FishSalmon", 1, 0.0);
rmSetObjectDefMinDistance(Fisch1, 0.3);
rmSetObjectDefMaxDistance(Fisch1, rmXFractionToMeters(0.5));
rmAddObjectDefConstraint(Fisch1, AVFishFish);
rmAddObjectDefConstraint(Fisch1, AVFishLand);
rmPlaceObjectDefAtLoc(Fisch1, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);
int Fisch2=rmCreateObjectDef("Fisch2");
rmAddObjectDefItem(Fisch2, "FishSalmon", 1, 0.0);
rmSetObjectDefMinDistance(Fisch2, 0.3);
rmSetObjectDefMaxDistance(Fisch2, rmXFractionToMeters(0.5));
rmAddObjectDefConstraint(Fisch2, AVFishFish);
rmAddObjectDefConstraint(Fisch2, AVFishLand);
rmPlaceObjectDefAtLoc(Fisch2, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);
for(I=1;< CliffCount)
{
int CliffID=rmCreateArea("Cliff"+I);
rmSetAreaSize(CliffID, rmAreaTilesToFraction(CLIFFSIZE), rmAreaTilesToFraction(CLIFFSIZE));
rmSetAreaCliffType(CliffID, "Carolina");
rmSetAreaCliffEdge(CliffID,2, 0.4, 0.5, 1.0, 0);
rmSetAreaCliffPainting(CliffID, false, true, true, 1.5, true);
rmSetAreaCliffHeight(CliffID, 5.5, 0.5, 0.5);
rmSetAreaHeightBlend(CliffID, 2);
rmSetAreaCoherence(CliffID,0.15);
rmAddAreaConstraint(CliffID, SPLAYER);
rmAddAreaConstraint(CliffID, AVTradeRoute);
rmAddAreaConstraint(CliffID, AVImpItem);
rmAddAreaConstraint(CliffID, AVWater8);
float XX = rmRandFloat(0.05,0.98);
float ZZ = rmRandFloat(0.05,0.98);
rmSetAreaLocation(CliffID, XX, ZZ);
rmSetAreaWarnFailure(CliffID, false);
rmBuildArea(CliffID);
}
int TCID = rmCreateObjectDef("player TC");
rmAddObjectDefItem(TCID, "townCenter", 1, 0);
rmSetObjectDefMinDistance(TCID, 0.0);
rmSetObjectDefMaxDistance(TCID, 20.0);
rmAddObjectDefConstraint(TCID, AVTradeRoute);
rmAddObjectDefConstraint(TCID, TCvsTC);
rmAddObjectDefConstraint(TCID, CWvsCW);
rmAddObjectDefConstraint(TCID, AVLAND1);
for(i=1; <cNumberPlayers)
{
rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
}
int ExplorerUnits = rmCreateStartingUnitsObjectDef(5.0);
rmSetObjectDefMinDistance(ExplorerUnits, 6.0);
rmSetObjectDefMaxDistance(ExplorerUnits, 10.0);
rmAddObjectDefConstraint(ExplorerUnits, AVAll);
rmAddObjectDefConstraint(ExplorerUnits, AVLAND2);
int playerBerryID=rmCreateObjectDef("player berries");
rmAddObjectDefItem(playerBerryID, "berryBush", 5, 5.0);
rmSetObjectDefMinDistance(playerBerryID, 8);
rmSetObjectDefMaxDistance(playerBerryID, 10);
rmAddObjectDefConstraint(playerBerryID, AVAll);
rmAddObjectDefConstraint(playerBerryID, AVLAND2);
int playerTreeID=rmCreateObjectDef("player trees");
rmAddObjectDefItem(playerTreeID, "TreeTexas", 5, 0.0);
rmSetObjectDefMinDistance(playerTreeID, 6);
rmSetObjectDefMaxDistance(playerTreeID, 12);
rmAddObjectDefConstraint(playerTreeID, AVAll);
rmAddObjectDefConstraint(playerTreeID, AVLAND2);
int wild1ID=rmCreateObjectDef("turkeys");
rmAddObjectDefItem(wild1ID, "turkey", 8, 8.0);
rmSetObjectDefMinDistance(wild1ID, 20);
rmSetObjectDefMaxDistance(wild1ID, 30);
rmAddObjectDefConstraint(wild1ID, AVANIMAL);
rmAddObjectDefConstraint(wild1ID, AVAll);
rmAddObjectDefConstraint(wild1ID, AVLAND1);
rmSetObjectDefCreateHerd(wild1ID, true);
int playerSilverID = rmCreateObjectDef("player silver");
rmAddObjectDefItem(playerSilverID, "mine",1, 4.0);
rmAddObjectDefConstraint(playerSilverID, AVTradeRoute);
rmSetObjectDefMinDistance(playerSilverID, 25.0);
rmSetObjectDefMaxDistance(playerSilverID, 30.0);
rmAddObjectDefConstraint(playerSilverID, AVAll);
rmAddObjectDefConstraint(playerSilverID, AVLAND2);
rmSetStatusText("",0.70);
for(i=1; <cNumberPlayers)
{
vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));
rmPlaceObjectDefAtLoc(ExplorerUnits, i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
for(x=1; <6)
{
rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
}
rmPlaceObjectDefAtLoc(playerBerryID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
rmPlaceObjectDefAtLoc(wild1ID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
}
int ExtraUnit1ID = rmCreateObjectDef("Extra1");
rmAddObjectDefItem(ExtraUnit1ID, "CoveredWagon",1, 6.0);
rmAddObjectDefConstraint(ExtraUnit1ID, AVTradeRoute);
rmSetObjectDefMinDistance(ExtraUnit1ID, 10.0);
rmSetObjectDefMaxDistance(ExtraUnit1ID, 20.0);
rmAddObjectDefConstraint(ExtraUnit1ID, AVAll);
rmAddObjectDefConstraint(ExtraUnit1ID, AVLAND2);
int ExtraUnit2ID = rmCreateObjectDef("Extra2");
rmAddObjectDefItem(ExtraUnit2ID, "Surgeon",2, 6.0);
rmAddObjectDefConstraint(ExtraUnit2ID, AVTradeRoute);
rmSetObjectDefMinDistance(ExtraUnit2ID, 10.0);
rmSetObjectDefMaxDistance(ExtraUnit2ID, 20.0);
rmAddObjectDefConstraint(ExtraUnit2ID, AVAll);
rmAddObjectDefConstraint(ExtraUnit2ID, AVLAND2);
int ExtraUnit3ID = rmCreateObjectDef("Extra3");
rmAddObjectDefItem(ExtraUnit3ID, "OutpostWagon",2, 6.0);
rmAddObjectDefConstraint(ExtraUnit3ID, AVTradeRoute);
rmSetObjectDefMinDistance(ExtraUnit3ID, 10.0);
rmSetObjectDefMaxDistance(ExtraUnit3ID, 20.0);
rmAddObjectDefConstraint(ExtraUnit3ID, AVAll);
rmAddObjectDefConstraint(ExtraUnit3ID, AVLAND2);
for(i=1; <cNumberPlayers)
{
TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));
rmPlaceObjectDefAtLoc(ExtraUnit1ID, i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
rmPlaceObjectDefAtLoc(ExtraUnit2ID, i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
rmPlaceObjectDefAtLoc(ExtraUnit3ID, i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
}
rmClearClosestPointConstraints();
rmSetStatusText("",0.80);
int Flagge = 1;
for(i=0; <cNumberPlayers)
{
TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));
Flagge=rmCreateObjectDef("Hafenflagge"+i);
rmAddObjectDefItem(Flagge, "HomeCityWaterSpawnFlag", 1, 1.0);
rmAddClosestPointConstraint(FLVSFL);
rmAddClosestPointConstraint(FLLAND);
rmPlaceObjectDefAtLoc(Flagge, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
}
rmClearClosestPointConstraints();
int VillageID1 = rmCreateGrouping("Seminole village1", "native Seminole village 4");
rmSetGroupingMinDistance(VillageID1, 10.0);
rmSetGroupingMaxDistance(VillageID1,rmXFractionToMeters(0.2));
rmAddGroupingConstraint(VillageID1, Cliff);
rmAddGroupingConstraint(VillageID1, rmClassID("MainItems"));
rmAddGroupingConstraint(VillageID1,AVTradeRoute);
rmAddGroupingConstraint(VillageID1,AVImpItem);
rmAddGroupingConstraint(VillageID1,AVNativeTrade);
rmAddGroupingConstraint(VillageID1,AVTC);
rmAddGroupingConstraint(VillageID1, rmClassID("Nativ"));
rmPlaceGroupingAtLoc(VillageID1, 0,0.15,0.60);
int VillageID2 = rmCreateGrouping("Comanche village2", "native Comanche village 1");
rmSetGroupingMinDistance(VillageID2, 10.0);
rmSetGroupingMaxDistance(VillageID2,rmXFractionToMeters(0.2));
rmAddGroupingConstraint(VillageID2, Cliff);
rmAddGroupingConstraint(VillageID2, rmClassID("MainItems"));
rmAddGroupingConstraint(VillageID2,AVTradeRoute);
rmAddGroupingConstraint(VillageID2,AVImpItem);
rmAddGroupingConstraint(VillageID2,AVNativeTrade);
rmAddGroupingConstraint(VillageID2,AVTC);
rmAddGroupingConstraint(VillageID2, rmClassID("Nativ"));
rmPlaceGroupingAtLoc(VillageID2, 0,0.20,0.65);
int VillageID3 = rmCreateGrouping("Lakota village3", "native Lakota village 2");
rmSetGroupingMinDistance(VillageID3, 10.0);
rmSetGroupingMaxDistance(VillageID3,rmXFractionToMeters(0.2));
rmAddGroupingConstraint(VillageID3, Cliff);
rmAddGroupingConstraint(VillageID3, rmClassID("MainItems"));
rmAddGroupingConstraint(VillageID3,AVTradeRoute);
rmAddGroupingConstraint(VillageID3,AVImpItem);
rmAddGroupingConstraint(VillageID3,AVNativeTrade);
rmAddGroupingConstraint(VillageID3,AVTC);
rmAddGroupingConstraint(VillageID3, rmClassID("Nativ"));
rmPlaceGroupingAtLoc(VillageID3, 0,0.60,0.45);
int VillageID4 = rmCreateGrouping("Nootka village4", "native Nootka village 3");
rmSetGroupingMinDistance(VillageID4, 10.0);
rmSetGroupingMaxDistance(VillageID4,rmXFractionToMeters(0.2));
rmAddGroupingConstraint(VillageID4, Cliff);
rmAddGroupingConstraint(VillageID4, rmClassID("MainItems"));
rmAddGroupingConstraint(VillageID4,AVTradeRoute);
rmAddGroupingConstraint(VillageID4,AVImpItem);
rmAddGroupingConstraint(VillageID4,AVNativeTrade);
rmAddGroupingConstraint(VillageID4,AVTC);
rmAddGroupingConstraint(VillageID4, rmClassID("Nativ"));
rmPlaceGroupingAtLoc(VillageID4, 0,0.65,0.40);
rmSetStatusText("",0.90);
int silverID = -1;
int silverCount = (cNumberNonGaiaPlayers * 1.5);
for(i=0; < silverCount)
{
silverID = rmCreateObjectDef("silver "+i);
rmAddObjectDefItem(silverID, "mine", 1, 0.0);
rmSetObjectDefMinDistance(silverID, 0.0);
rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(1));
rmAddObjectDefConstraint(silverID, AVCoin);
rmAddObjectDefConstraint(silverID, AVAll);
rmAddObjectDefConstraint(silverID, AVTC);
rmAddObjectDefConstraint(silverID, AVCW);
rmAddObjectDefConstraint(silverID, AVSilverSockets);
rmAddObjectDefConstraint(silverID, AVLAND3);
rmAddObjectDefConstraint(silverID, AVTradeRoute);
rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
}
int GoldID = -1;
int GoldCount = (cNumberNonGaiaPlayers * 1.5);
for(i=0; < GoldCount)
{
GoldID = rmCreateObjectDef("Gold "+i);
rmAddObjectDefItem(GoldID, "mineGold", 1, 0.0);
rmSetObjectDefMinDistance(GoldID, 0.0);
rmSetObjectDefMaxDistance(GoldID, rmXFractionToMeters(1));
rmAddObjectDefConstraint(GoldID, AVCoin);
rmAddObjectDefConstraint(GoldID, AVAll);
rmAddObjectDefConstraint(GoldID, AVTC);
rmAddObjectDefConstraint(GoldID, AVCW);
rmAddObjectDefConstraint(GoldID, AVSilverSockets);
rmAddObjectDefConstraint(GoldID, AVLAND3);
rmAddObjectDefConstraint(GoldID, AVTradeRoute);
rmPlaceObjectDefAtLoc(GoldID, 0, 0.5, 0.5);
}
int SchatzID = -1;
int SchatzCount = (cNumberNonGaiaPlayers * 1.5);
for(i=0; < SchatzCount)
{
SchatzID = rmCreateObjectDef("Schatz "+i);
rmAddObjectDefItem(SchatzID, "nugget", 1, 0.0);
rmSetObjectDefMinDistance(SchatzID, 0.0);
rmSetObjectDefMaxDistance(SchatzID, rmXFractionToMeters(1));
rmAddObjectDefConstraint(SchatzID, AVCoin);
rmAddObjectDefConstraint(SchatzID, AVAll);
rmAddObjectDefConstraint(SchatzID, AVTC);
rmAddObjectDefConstraint(SchatzID, AVCW);
rmAddObjectDefConstraint(SchatzID, AVNugget);
rmAddObjectDefConstraint(SchatzID, AVLAND3);
rmAddObjectDefConstraint(SchatzID, AVTradeRoute);
rmPlaceObjectDefAtLoc(SchatzID, 0, 0.5, 0.5);
}
int WildAID=rmCreateObjectDef("capybara-1");
rmAddObjectDefItem(WildAID, "capybara", 20, 20);
rmSetObjectDefMinDistance(WildAID, 30);
rmSetObjectDefMaxDistance(WildAID, 40);
rmAddObjectDefConstraint(WildAID, AVANIMAL);
rmAddObjectDefConstraint(WildAID, AVAll);
rmAddObjectDefConstraint(WildAID, AVTC);
rmAddObjectDefConstraint(WildAID, AVCW);
rmAddObjectDefConstraint(WildAID, AVLAND1);
rmSetObjectDefCreateHerd(WildAID, true);
rmPlaceObjectDefAtLoc(WildAID, 0, 0.85,0.5,1);
int WildBID=rmCreateObjectDef("elk-2");
rmAddObjectDefItem(WildBID, "elk", 30, 20);
rmSetObjectDefMinDistance(WildBID, 30);
rmSetObjectDefMaxDistance(WildBID, 40);
rmAddObjectDefConstraint(WildBID, AVANIMAL);
rmAddObjectDefConstraint(WildBID, AVAll);
rmAddObjectDefConstraint(WildBID, AVTC);
rmAddObjectDefConstraint(WildBID, AVCW);
rmAddObjectDefConstraint(WildBID, AVLAND1);
rmSetObjectDefCreateHerd(WildBID, true);
rmPlaceObjectDefAtLoc(WildBID, 0, 0.50,0.85,1);
int WildCID=rmCreateObjectDef("cow-3");
rmAddObjectDefItem(WildCID, "cow", 20, 20);
rmSetObjectDefMinDistance(WildCID, 30);
rmSetObjectDefMaxDistance(WildCID, 40);
rmAddObjectDefConstraint(WildCID, AVANIMAL);
rmAddObjectDefConstraint(WildCID, AVAll);
rmAddObjectDefConstraint(WildCID, AVTC);
rmAddObjectDefConstraint(WildCID, AVCW);
rmAddObjectDefConstraint(WildCID, AVLAND1);
rmSetObjectDefCreateHerd(WildCID, true);
rmPlaceObjectDefAtLoc(WildCID, 0, 0.5,0.15,1);
int WildDID=rmCreateObjectDef("muskOx-4");
rmAddObjectDefItem(WildDID, "muskOx", 20, 20);
rmSetObjectDefMinDistance(WildDID, 30);
rmSetObjectDefMaxDistance(WildDID, 40);
rmAddObjectDefConstraint(WildDID, AVANIMAL);
rmAddObjectDefConstraint(WildDID, AVAll);
rmAddObjectDefConstraint(WildDID, AVTC);
rmAddObjectDefConstraint(WildDID, AVCW);
rmAddObjectDefConstraint(WildDID, AVLAND1);
rmSetObjectDefCreateHerd(WildDID, true);
rmPlaceObjectDefAtLoc(WildDID, 0, 0.15,0.5,1);
int forestTreeID = 0;
int numTries = ForestCount;
int failCount=0;
for (i=0; <numTries)
{
int forest=rmCreateArea("forest "+i);
rmSetAreaWarnFailure(forest, false);
rmSetAreaSize(forest, rmAreaTilesToFraction(FORESTSIZE), rmAreaTilesToFraction(FORESTSIZE));
rmSetAreaForestType(forest, "Texas Forest");
rmSetAreaForestDensity(forest, 0.9);
rmSetAreaForestClumpiness(forest, 1);
rmSetAreaForestUnderbrush(forest, 1);
rmSetAreaMinBlobs(forest, 1);
rmSetAreaMaxBlobs(forest, 5);
rmSetAreaMinBlobDistance(forest, 12.0);
rmSetAreaMaxBlobDistance(forest, 16.0);
rmSetAreaCoherence(forest, 0.4);
rmSetAreaSmoothDistance(forest, 5);
rmAddAreaToClass(forest, rmClassID("MainForest"));
rmAddAreaConstraint(forest, FOvsFO);
rmAddAreaConstraint(forest, AVAll);
rmAddAreaConstraint(forest, FOvsTC);
rmAddAreaConstraint(forest, FOvsCW);
rmAddAreaConstraint(forest, AVLAND3);
rmAddAreaConstraint(forest, AVTradeRoute);
if(rmBuildArea(forest)==false)
{
failCount++;
if(failCount==5)
break;
}
else
failCount=0;
}

}
